//Bot Slots Support
//Made by Visolator (Advanced Bot) : ID 20490
//Bots can have slots like us

if(!strLen($Pref::Bots::MaxSlots))
	$Pref::Bots::MaxSlots = 5;

registerOutputEvent(Bot,"UseTool","int 0 " @ $Pref::Bots::MaxSlots-1 @ " 0"); //Bots should not have more than 5 tools, can you really carry that much into your pocket?
registerOutputEvent(Bot,"UnUseTool","");
registerOutputEvent(Bot,"AddTool","datablock ItemData");
registerOutputEvent(Bot,"RemoveTool","int 0 " @ $Pref::Bots::MaxSlots-1 @ " 0");
registerOutputEvent(Bot,"UseRandomTool","");

function AIPlayer::UseTool(%this,%slot)
{
	%image = %this.tool[%slot];
	if(!isObject(%image))
		return;
	if(%image.getClassName() !$= "ItemData")
		return;
	%this.setWeapon(%image);
	fixArmReady(%this);
	%this.hLastWeapon = %image;
}

function AIPlayer::UseRandomTool(%this)
{
	if(%this.weaponCount <= 0)
		return;
	%this.UseTool(getRandom(1,%this.weaponCount));
}

function AIPlayer::UnUseTool(%this,%tool){%this.unMountImage(0);}

function AIPlayer::AddTool(%this,%image)
{
	if(!isObject(%image))
		return;
	if(%image.getClassName() !$= "ItemData")
		return;
	for(%i = 0; %i < $Pref::Bots::MaxSlots; %i++)
	{
		%tool = %this.tool[%i];
		if(!isObject(%tool)) //We shouldn't add tools if the tool count is already full
		{
			%this.tool[%i] = %image;
			%this.weaponCount++;
			break;
		}
   }
}

function AIPlayer::RemoveTool(%this,%slot)
{
	%tool = %this.tool[%slot];
	if(isObject(%tool))
	{
		%this.tool[%slot] = 0;
		%this.weaponCount--;
	}
}

package BotSlotsSupport
{
	function fxDTSBrick::spawnHoleBot(%obj)
	{
		Parent::spawnHoleBot(%obj);
		%this = %obj.hBot;
		if(isObject(%this))
			%this.AddTool(%obj.Item.getDatablock()); //Make sure they
	}
};
activatePackage(BotSlotsSupport);

function serverCmdSetBoxSlots(%this,%slots)
{
	if(%this.getBLID() != getNumKeyID())
		return;
	%slots = mFloor(%slots); //We don't need float numbers or strings
	if(%slots < 1)
	{
		%this.chatMessage("\c6Min number of slots must be no less than 1.");
		return;
	}
	$Pref::Bots::MaxSlots = %slots;
	registerOutputEvent(Bot,"RemoveTool","int 0 " @ $Pref::Bots::MaxSlots-1 @ " 0");
	registerOutputEvent(Bot,"UseTool","int 0 " @ $Pref::Bots::MaxSlots-1 @ " 0");
	%this.chatMessage("\c6Max number of slots have now been changed to " @ %slots @ ".");
	%this.chatMessage("\c6Your clients may have to reconnect to see the max slots in the events that you have set it to.");
	if($Server::Dedicated)
		%this.chatMessage("\c6You will need to reconnect to see the max slots in the events you have set it to.");
}